# Generated by Django 3.2 on 2021-06-07 02:23

from django.db import migrations, models
import django.db.models.deletion


# Generated by Django 3.2 on 2021-06-05 01:56

from typing import List


from swift_lyrics.models import Album, Artist , Lyric , Song
import json


def load_initial_artist_data(apps, schema_editor):

    with open('swift_lyrics/fixtures/artist.json') as json_data:
        artist_data = json.load(json_data)
        
        for artist in artist_data["swift_lyrics_artist"]:

            name:str = artist["name"]
            first_year:str = artist["first_year"]
            
            current_artist = Artist.objects.filter(name=name).first()

            if current_artist is None : 
                current_artist = Artist(name = name , first_year = first_year)

                current_artist.save()
            
            first_artist =  "Taylor Swift".lower()

            
            if name.lower() == first_artist:
                albums:List[Album]=Album.objects.all()
                for album in albums:
                    album.artist=current_artist
                    album.save()

                    album_lyrics: List[Lyric] = Lyric.objects.filter(song__album=album)
                    

                    for album_lyric in album_lyrics:
                        album_lyric.album = album
                        album_lyric.save()
                    
                    
                
def load_initial_data(apps, schema_editor):
    json_data = open('swift_lyrics/fixtures/quotes.json')
    
    data = json.load(json_data)
    for d in data:
        album_name = d['album']
        song_name = d['song']
        text = d['quote']

        album = Album.objects.filter(name=album_name).first()
        if album is None:
            album = Album(name=album_name)
            album.save()

        song = Song.objects.filter(name=song_name).first()
        if song is None:
            song = Song(name=song_name, album=album)
            song.save()

        Lyric(song=song, text=text).save()
    json_data.close()

class Migration(migrations.Migration):

    initial = True

    dependencies = [
    ]

    operations = [
        migrations.CreateModel(
            name='Album',
            fields=[
                ('id', models.BigAutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('name', models.TextField(db_index=True, help_text="Album name - can alternatively use 'id' field set to id of existing album when creating new lyrics", unique=True)),
                ('year', models.IntegerField(null=True)),
            ],
        ),
        migrations.CreateModel(
            name='Artist',
            fields=[
                ('id', models.BigAutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('name', models.TextField(help_text='Artist name - Artist name name required', unique=True)),
                ('first_year', models.IntegerField(null=True)),
            ],
        ),
        migrations.CreateModel(
            name='Song',
            fields=[
                ('id', models.BigAutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('name', models.TextField(db_index=True, help_text="Song name - can alternatively use 'id' field set to id of existing song when creating new lyrics", unique=True)),
                ('album', models.ForeignKey(help_text='Album', null=True, on_delete=django.db.models.deletion.CASCADE, related_name='songs', to='swift_lyrics.album')),
            ],
        ),
        migrations.CreateModel(
            name='Lyric',
            fields=[
                ('id', models.BigAutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('text', models.TextField(db_index=True, help_text='Lyrics from a song/album')),
                ('votes', models.IntegerField(default=0)),
                ('upvote', models.IntegerField(default=0, help_text='Number of upvotes for the current lyric')),
                ('downvote', models.IntegerField(default=0, help_text='Number of downvotes for the current lyric')),
                ('album', models.ForeignKey(null=True, on_delete=django.db.models.deletion.CASCADE, to='swift_lyrics.album')),
                ('song', models.ForeignKey(help_text='Song', null=True, on_delete=django.db.models.deletion.CASCADE, related_name='lyrics', to='swift_lyrics.song')),
            ],
        ),
        migrations.AddField(
            model_name='album',
            name='artist',
            field=models.ForeignKey(null=True, on_delete=django.db.models.deletion.CASCADE, related_name='album', to='swift_lyrics.artist'),
        ),
        migrations.AlterUniqueTogether(
            name='album',
            unique_together={('artist_id', 'name')},
        ),
        migrations.RunPython(load_initial_data),
        migrations.RunPython(load_initial_artist_data)

    ]
